#! /usr/bin/python
# -*- encoding:UTF-8 --*--
import urlgrabber
from urlgrabber import progress
import threading,Queue
from PyQt4.QtGui import *
from PyQt4.QtCore import *
import sys
import utils
import config
import shutil

STATE_COLUMN=6
def updatemodel(musicitem,column=STATE_COLUMN):
    for model in musicitem.downloadmodels:	
	container=model.musiccontainer
	modelindex=model.index(list(container).index(musicitem),column)
	model.emit(SIGNAL(
		    'dataChanged(const QModelIndex &, const QModelIndex &)'),
		    modelindex,modelindex)
class TextMeter(urlgrabber.progress.BaseMeter,QObject):
    def __init__(self,musicitem):
        urlgrabber.progress.BaseMeter.__init__(self)
	QObject.__init__(self)
	self.musicitem=musicitem
	self.updateEvent=SIGNAL('updateEvent')
    def _do_update(self, amount_read, now=None):
        etime = self.re.elapsed_time()
        fetime = progress.format_time(etime)
        fread = progress.format_number(amount_read)
        if self.text is not None:
            text = self.text
        else:
            text = self.basename
        if self.size is None:
            out = ' %-60.60s    %5sB %s ' % \
                  (text, fread, fetime)
        else:
            rtime = self.re.remaining_time()
            frtime = progress.format_time(rtime)
            frac = self.re.fraction_read()
            bar = '='*int(25 * frac)

            out = u' %3i%% %8s 剩余 ' % \
                  ( frac*100, frtime)

	self.musicitem.__setattr__('state',out)
	updatemodel(self.musicitem)
	'''
	container=self.musicitem.container
	model=self.musicitem.model
	modelindex=model.index(list(container).index(self.musicitem),STATE_COLUMN)
	model.emit(SIGNAL(
                    'dataChanged(const QModelIndex &, const QModelIndex &)'),
                    modelindex,modelindex)
	'''
    def _do_end(self, amount_read, now=None):
        total_time = progress.format_time(self.re.elapsed_time())
        total_size = progress.format_number(amount_read)
        if self.text is not None:
            text = self.text
        else:
            text = self.basename
        if self.size is None:
            out = ' %-60.60s    %5sB %s ' % \
                  (text, total_size, total_time)
        else:
            bar = '='*25
            out = ' %3i%% %8s' % \
                  (100, total_time)
	self.musicitem.__setattr__('state',out)
	updatemodel(self.musicitem)
	'''
	container=self.musicitem.container
	model=self.musicitem.model
	modelindex=model.index(list(container).index(self.musicitem),STATE_COLUMN)
	model.emit(SIGNAL(
                    'dataChanged(const QModelIndex &, const QModelIndex &)'),
                    modelindex,modelindex)
	'''
class MusicDownloaderThread(threading.Thread):
    def __init__(self,queue,parent=None):
	'''
	musicitem: Music object
	'''
	super(MusicDownloaderThread,self).__init__()	
	self.queue=queue
	
    def run(self):
	while True:
	    musicitem=self.queue.get()
	    if musicitem.isDownloading==True or musicitem.isDownloaded==True:
		pass
	    else:
		musicitem.isDownloading=True
		progmeter=TextMeter(musicitem)
		import utils	
		import os
		try:
		    ext=musicitem.url.split('.')[-1]#.encode('utf-8')
		    origname=musicitem.url.split('/')[-1]
		    filetempname=os.path.join(u'%s%s.temp'%(config.savetempdir,origname))
		    filename=os.path.join('%s%s.%s'%(config.savedir,musicitem.title,ext))
		    if os.path.exists(filename) and not config.overwrite:
			musicitem.state=u"文件已存在！忽略"
		    else:
			utils.download(musicitem.url,filename=filetempname,prog=progmeter) 
			musicitem.isDownloaded=True
			shutil.move(filetempname,filename)
			try:os.remove(filetempname)
			except:pass
		except:		    
		    musicitem.state=u"下载出错，请重试!"
		    utils.logging.exception('got error while downloading %s %s',musicitem.title,musicitem.url)
		musicitem.isDownloading=False
		updatemodel(musicitem)
		self.queue.task_done()
		
class MusicDownloader(object):
    def __init__(self):
	self.queue=Queue.Queue()
	for x in range(config.downloadthreadcount): # create 4 threads to do the download work.
	    t=MusicDownloaderThread(self.queue)
	    t.setDaemon(True)
	    t.start()	
    def download(self,musicitems):
	for music in musicitems:
	    if music.isDownloading==True or music.isDownloaded==True:
		continue
	    music.state=u'等待下载中'
	    self.queue.put(music)
if __name__=='__main__':
    gettopsongs()
