import os
import subprocess
import select

class MplayerUI(object):
    exe_name = 'mplayer' if os.sep == '/' else 'mplayer.exe'
    def __init__(self,wid=None):
	if wid is not None:
	    self._mplayer=subprocess.Popen('%s -wid %s -slave -really-quiet -idle'%(self.exe_name,wid),stdout=subprocess.PIPE,stdin=subprocess.PIPE,shell=True)
	else:
	    self._mplayer=subprocess.Popen('%s -slave -quiet -idle'%self.exe_name,stdout=subprocess.PIPE,stdin=subprocess.PIPE,shell=True)
	self._readlines()
    def _readlines(self):
        ret = []
        while any(select.select([self._mplayer.stdout.fileno()], [], [], 0.6)):
            ret.append( self._mplayer.stdout.readline() )
        return ret
    def format_time(self,seconds, use_hours=0):
	if seconds is None or seconds < 0:
	    if use_hours: return '--:--:--'
	    else:         return '--:--'
	else:
	    seconds = int(seconds)
	    minutes = seconds / 60
	    seconds = seconds % 60
	    if use_hours:
		hours = minutes / 60
		minutes = minutes % 60
		return '%02i:%02i:%02i' % (hours, minutes, seconds)
	    else:
		return '%02i:%02i' % (minutes, seconds)
    def command(self, name, *args):
        """ Very basic interface [see populate()]
        Sends command 'name' to process, with given args
        """
        cmd = '%s%s%s\n'%(name,
                ' ' if args else '',
                ' '.join(repr(a) for a in args)
                )
        self._mplayer.stdin.write(cmd)
        if name == 'quit':
            return
        return self._readlines()
	
    @classmethod
    def populate(kls):
	def args_pprint(txt):
            lc = txt.lower()
            if lc[0] == '[':
                return '%s=None'%lc[1:-1]
            return lc
	mp=subprocess.Popen('%s -input cmdlist'%kls.exe_name,stdout=subprocess.PIPE,stdin=subprocess.PIPE,shell=True)
	while True:
	    line=mp.stdout.readline()
	    if not line:
		break
	    if line[0].isupper():
		continue
	    args=line.split()
	    cmd_name=args.pop(0)
	    arguments=','.join([args_pprint(a) for a in args])
	    func_str = '''def _populated_fn(self, *args):
            """%(doc)s"""
            if not (%(minargc)d <= len(args) <= %(argc)d):
                raise TypeError('%(name)s takes %(argc)d arguments (%%d given)'%%len(args))
            ret = self.command('%(name)s', *args)
            if not ret:
                return None
            if ret[0].startswith('ANS'):
                val = ret[0].split('=', 1)[1].rstrip()
                try:
                    return eval(val)
                except:
                    return val
            return ret'''%dict(
                    doc = '%s(%s)'%(cmd_name, arguments),
                    minargc = len([a for a in args if a[0] != '[']),
                    argc = len(args),
                    name = cmd_name,
                    )
            exec(func_str)
	    setattr(kls, cmd_name, _populated_fn)	
	mp.wait()
	mp.stdin.close()
	mp.stdout.close()
if __name__=='__main__':
    MplayerUI.populate()
    mp=MplayerUI()
    import pdb;pdb.set_trace()
    mp.loadfile('/media/wind/test.mkv')
    
