#! /usr/bin/python
# -*- encoding:UTF-8 --*--
import threading,Queue
from lxml import etree
from urlparse import urlparse
from urllib import urlencode
from urllib2 import urlopen
from utils import printtag,cleanuptag,readurl,disUrl,logger
from datetime import datetime
import re
from PyQt4.QtCore import SIGNAL

#HOST='http://list.mp3.baidu.com/list/qingyinyue.html'
import models
import config

class GetSongThread(threading.Thread):
	def __init__(self,queue):
	    threading.Thread.__init__(self)
	    self.queue=queue
	def run(self):
	    while True:
		try:
		    musicitem=self.queue.get()
		    album,realurl,stype,size=self.getsonginfo(musicitem.songurl)
		    if album and realurl and stype and size:			
			musicitem.album=album
			musicitem.url=realurl.encode('gb18030').decode('gb18030')
			musicitem.stype=stype
			musicitem.size=size
			self.updatemodel(musicitem)
		    self.queue.task_done()		    
		except:
		    pass
	    
	def getsonginfo(self,songurl):
	    root=readurl(songurl,'gb18030')    
	    tables=root.xpath(".//table[@id='Tbs']")
	    breakable=False
	    album=''
	    realurl=''
	    stype=''
	    size=''
	    for table in tables:
		if breakable:break
		trs=table.xpath(".//tr")
		for tr in trs:
		    if breakable:break
		    tds=tr.xpath(".//td")
		    album=None
		    realurl=None
		    stype=None
		    size=None
		    for td in tds:
			#import pdb;pdb.set_trace()		
			if td.get('class','')=='al':
			    album=cleanuptag(td,encoding='gb18030').decode('gb18030')
			elif tds.index(td)==7:		    
			    size=td.text
			elif tds.index(td)==8:
			    stype=td.text
			elif td.get('class','')=='d':
			    #import pdb;pdb.set_trace()
			    url=td.getchildren()[0].get('href')			    
			    try:
				realurl= self.decode(url)
				urlopen(realurl)
				breakable=True
			    except:
				continue
		    if breakable and self.checkfile(size,stype):
			breakable=True
		    else:breakable=False
	    #if the loop is done, but still got no valid song. here I need to verity it again to make
	    #sure the last one is valid too.
	    if self.checkfile(size,stype):
		return (album,realurl,stype,size)
	    else:
		return (None,None,None,None)
	#    import pdb;pdb.set_trace()
	def checkfile(self,size,filetype):
	    try:
		size=float(size.split(' ')[0])
		if config.minfilesize<=size<=config.maxfilesize and filetype in config.filetypes:
		    return True
	    except:pass
	    return False
	def decode(self,mp3downurl):   
	    '''
	    schema,netloc,path,param,query,frag=urlparse(mp3downurl.encode('utf-8'))
	    queryparams={}
	    query=query.split('&')
	    for item in query:
		name,value=item.split('=')
		if name=='tn':
		    queryparams[name]=value.split(',')[0]
		else:queryparams[name]=value
	    newquery=urlencode(queryparams)
	    newurl="%s://%s/%s?%s"%(schema,netloc,path,newquery)
	    #print newurl
	    '''
	    
	    url=mp3downurl
	    ch=url.find('baidusg')
	    newurl=url[:ch+7]+url[url.find('&',ch):]    
	    
	    #import pdb;pdb.set_trace()
	    root=readurl(newurl,encoding='gb18030')
	    cnt=etree.tostring(root)
	    def decode(code,end='"'):
		startx=cnt.find(code)
		endx=cnt.find(end,startx+len(code))
		return startx+len(code),endx
		
	    x,y=decode('var I="')
	    I=cnt[x:y]
	    x,y=decode(',J="')
	    J=cnt[x:y]
	    x,y=decode('var F=',',')
	    F=cnt[x:y]
	    #import pdb;pdb.set_trace()
	    if F.isdigit():
		return disUrl(int(F),I,J)
	    else:
		logger.warn('no Digit in F: %s, the html source is %s',F,cnt)

	def updatemodel(self,musicitem):
	    for model in musicitem.fetchmodels:
		if model:
		    model.insertRows(model.rowCount()-1,musicitems=[musicitem])
	    
class BaiduMusicFetcher(threading.Thread):
    '''
    music fetcher to get the musics.
    '''
    def __init__(self,hosturl,model=None):
	super(BaiduMusicFetcher,self).__init__()
	self.host=hosturl
	#model: the QAbstractTableModel
	self.model=model
	self.queue=Queue.Queue()
	self.homepagetablexpath=".//table[@class='list']"
	for x in range(config.fetchthreadcount):
	    t=GetSongThread(self.queue)
	    t.setDaemon(True)
	    t.start()
    def run(self):
	logger.info('starting...')
	self.gettopsongs()
    def getmainpagetables(self,root):
	'''
	subclass can reimplement this method to provide tables in mainpage in different ways.
	'''
	return root.xpath(self.homepagetablexpath)
    def gettopsongs(self):
	root=readurl(self.host,encoding='gb18030')
	#root=etree.HTML(urlopen(HOST).read().decode('gb18030'))
	tables=self.getmainpagetables(root)
	for table in tables:
	    trs=table.xpath(".//tr")
	    for tr in trs:
		'''
		td contains the song info in the following order:
		rank, (songname,singer(s)),like the following:
		1.      我和你  (刘欢/莎拉布莱曼)   2.      北京欢迎你  (群星)      3.      日不落  (蔡依林)
		'''
		#printtag(tr)
		#logger.info(printtag(tr))
		songs=self.parsetr(tr)
		for rank,title,url,singers in songs:
		    musicitem=models.Music(rank,title,singers,'')
		    musicitem.songurl=url
		    musicitem.singer=u", ".join(singers)
		    musicitem.fetchmodels.append(self.model)
		    self.queue.put(musicitem)
		    #import pdb;pdb.set_trace()
		    #album,realurl,stype,size=self.getsonginfo(url)
		    
		    #models.savemusic(models.Music(rank,title,u", ".join(singers),realurl,album=album,stype=stype,size=size,addeddate=datetime.now(),))
		    #logger.info( "%s       %s      %s	%s	%s	%s  %s"%(rank,title,u", ".join(singers),album.decode('utf-8'),stype,size,realurl))
		    #print "%s       %s      %s	%s	%s	%s  %s"%(rank,title,u", ".join(singers),album.decode('utf-8'),stype,size,realurl)
    def parsetr(self,tag):
	ranks=[]
	songtitles=[]
	songurls=[]
	songsingers=[]
	tds=tag.xpath(".//td")
	i=0
	def gettitle(a):
	    if a.getchildren():
		return a.getchildren()[0].text
	    return a.text
	#import pdb;pdb.set_trace()
	for td in tds:
	    singers=[]
	    if i%2==0:
		ranks.append(td.text)
	    else:
		x=0
		ass=td.xpath(".//a")            
		for a in ass:
		    if x==0:
			songtitles.append(u'%s'%gettitle(a))
			songurls.append(a.get('href'))
		    else:
			singers.append(a.text)
		    x+=1
		    
		songsingers.append(singers)
	    i+=1
	return zip(ranks,songtitles,songurls,songsingers)
    
class topfhFetcher(BaiduMusicFetcher):pass
class lightmusicFetcher(BaiduMusicFetcher):pass
class moviemusicFetcher(BaiduMusicFetcher):
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
class schoolmusicFetcher(BaiduMusicFetcher):
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
class quyimusicFetcher(BaiduMusicFetcher):
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
class mingyuemusicFetcher(BaiduMusicFetcher):
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
class xiangshengmusicFetcher(BaiduMusicFetcher):
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
class junlvmusicFetcher(BaiduMusicFetcher):
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
class liujinmusicFetcher(BaiduMusicFetcher):
    def getmainpagetables(self,root):
	try:
	    return [root.xpath('.//table')[2]]
	except:pass
	return []
	
if __name__=='__main__':
    f=liujinmusicFetcher('http://list.mp3.baidu.com/list/liujinsuiyue.html?top24')
    f.setDaemon(True)
    f.start()
