#! /usr/bin/python
# -*- encoding:utf-8 -*-
import ui_downloadwidgetui
import ui_aboutmusicdownloader
import ui_optiondialog
import ui_mainwindow
import ui_playerwidget

from PyQt4.QtGui import *
from PyQt4.QtCore import *
import os

import models
import downloader
import utils
import scrawler
from mplayer import MplayerUI
from mixin import MixIn
from threading import Thread
from Queue import Queue
import config

STATE_COLUMN=6
headers=(
    u'排行',
    u'歌曲名',
    u'歌手',
    u'专辑',
    u'类型',
    u'大小(M)',
    u'状态',
         )
baiducaturls=[
    'http://list.mp3.baidu.com/topso/mp3topsong.html',
    'http://list.mp3.baidu.com/list/qingyinyue.html',
    'http://list.mp3.baidu.com/xiaoyuan/mp3topsong.html?top13',
    'http://list.mp3.baidu.com/list/movies.html?top4',
    'http://list.mp3.baidu.com/list/quyi.html?top18',
    'http://list.mp3.baidu.com/list/minyue.html?top20',
    'http://list.mp3.baidu.com/list/xiangsheng.html?top17',
    'http://list.mp3.baidu.com/list/junge.html?top16',
    'http://list.mp3.baidu.com/list/liujinsuiyue.html?top24',
    ]
baiducat=['topfh',
          'lightmusic',
          'schoolmusic',
          'moviemusic',
          'quyimusic',
          'mingyuemusic',
          'xiangshengmusic',
          'junlvmusic',
          'liujinmusic']
baiducatnames=[u'Top500',
          u'轻音乐',
          u'校园歌曲',
          u'电影金曲',
          u'曲艺集锦',
          u'中国民乐',
          u'相声荟萃',
          u'军旅歌曲',
          u'流金岁月', ]
class MusicTableModel(QAbstractTableModel):
    def __init__(self, parent=None):
        super(MusicTableModel, self).__init__(parent)
        self.musiccontainer=models.MusicContainer()
	for music in self.musiccontainer:
	    music.__setattr__('model', self)
    def rowCount(self, index=QModelIndex):
        if self.musiccontainer is None:
            return 0
        return len(self.musiccontainer)
    def columnCount(self, index=QModelIndex):
        return 7
    def data(self, modelindex, role=Qt.DisplayRole):
        if self.musiccontainer is None:
            return QVariant()
        if not modelindex.isValid() or not (0<= modelindex.row() < len(self.musiccontainer)):
            return QVariant()
        music=self.musiccontainer[modelindex.row()]
        column=modelindex.column()
        if role==Qt.DisplayRole or role==Qt.ToolTipRole or role==Qt.StatusTipRole:
            return QVariant(music[column])
        #elif role==Qt.TextColorRole and music[column]=='Null':
        #    return QVariant(QColor(Qt.red))
        return QVariant()
    def headerData (self, section, orientation, role=Qt.DisplayRole):
        if orientation== Qt.Horizontal and role==Qt.DisplayRole:
            return QVariant(headers[section])#.decode('utf-8'))
        elif orientation== Qt.Vertical and role==Qt.DisplayRole:
            #return QVariant(int(section+1))
	    return QVariant()
        return QVariant()
    def insertRows(self, position, rows=1, index=QModelIndex(), musicitems=[]):
	self.beginInsertRows(QModelIndex(), position, position+rows-1)
	for row in range(rows):
	    musicitems[row].model=self
	    self.musiccontainer.insert(position+row, musicitems[row])
	self.endInsertRows()
	self.dirty=True
	return True
    def update(self, musicitem):	
	i=0
	for x in musicitem:
	    utils.logger.info('column %s,value:%s', i, x)
	    index=self.createIndex(list(musicitem.container).index(musicitem), i, x)	    
	    self.setData(index, QVariant(x))
	    i+=1
    def setData (self, index, value, role=Qt.EditRole):
	if index.isValid() and 0<=index.row()<len(self.musiccontainer):
	    musicitem=self.musiccontainer[index.row()]
	    column=index.column()
	    musicitem[column]=value.toString()
	    self.dirty=True
	    self.emit(SIGNAL(
		'dataChanged(const QModelIndex &, const QModelIndex &)'),
		index, index)
	    return True
	return False
    def sort(self, column, order = Qt.AscendingOrder):
	self.musiccontainer=sorted(self.musiccontainer)
	self.reset()
class AboutDialog(QDialog, ui_aboutmusicdownloader.Ui_Dialog):
    def __init__(self, parent=None):
	super(AboutDialog, self).__init__(parent)
	self.setupUi(self)
class OptionDialog(QDialog, ui_optiondialog.Ui_Dialog):
    def __init__(self, parent=None):
	super(OptionDialog, self).__init__(parent)
	self.setupUi(self)
	self.loadconfig()
    @pyqtSignature("QTreeWidgetItem *,int")
    def on_treeWidget_itemActivated(self, item, column):
	index=self.treeWidget.indexFromItem(item)
	self.stackedWidget.setCurrentIndex(index.row())
    @pyqtSignature("QTreeWidgetItem *,int")
    def on_treeWidget_itemClicked(self, item, column):
	index=self.treeWidget.indexFromItem(item)
	self.stackedWidget.setCurrentIndex(index.row())
    @pyqtSignature('')
    def on_btnBrowser_clicked(self):
	filename=QFileDialog.getExistingDirectory()
        if filename:
            self.txtSaveDir.setText(filename)
    @pyqtSignature('')
    def on_btnBrowserTem_clicked(self):
	filename=QFileDialog.getExistingDirectory()
        if filename:
            self.txtSaveTempDir.setText(filename)
    def validate(self):
	
	if self.dsbMaxSize.value()<self.dsbMinSize.value():
	    QMessageBox.warning(self, u'出错了', '文件大小设置出错!')
	    return False
	if not os.path.exists(self.txtSaveDir.text()):
	    #self.txtSaveDir.setText(u'路径无效')
	    self.txtSaveDir.selectAll()
	    self.txtSaveDir.setFocus()
	    self.treeWidget.setCurrentItem(self.treeWidget.topLevelItem(1))
	    return False
	if not os.path.exists(self.txtSaveTempDir.text()):
	   # self.txtSaveTempDir.setText(u'路径无效')  
	    self.txtSaveTempDir.selectAll()
	    self.txtSaveTempDir.setFocus()
	    self.treeWidget.setCurrentItem(self.treeWidget.topLevelItem(1))
	    return False
	'''
	if not os.path.exists(self.txtPlayer.text()):
	   # self.txtSaveTempDir.setText(u'路径无效')  
	    self.txtPlayer.selectAll()
	    self.txtPlayer.setFocus()
	    self.treeWidget.setCurrentItem(self.treeWidget.topLevelItem(0))
	    return False
	'''
	if self.txtSaveDir.text()[-1]!=os.sep:
	     self.txtSaveDir.setText(self.txtSaveDir.text()+os.sep)
	if self.txtSaveTempDir.text()[-1]!='/':
	     self.txtSaveTempDir.setText(self.txtSaveTempDir.text()+os.sep)
	return True
	
    def loadconfig(self):
	import config
	'''
	fetchthreadcount=4
	downloadthreadcount=4
	savedir='/home/shrek/Music/'#must end with '/'
	savetempdir='/home/shrek/Music/temp/'#must end with '/'
	overwrite=False #if local file exists, overwrite it?
	minfilesize=3 #if file size less than this, don't get the song info. (M)
	maxfilesize=10 #if file size larger than this, don't get the song info. (M)
	filetypes=['mp3','wma'] #file type to get,if file type is not in this list, don't get the song info
	'''
	self.pbFetchThreadCount.setValue(int(config.fetchthreadcount))
	self.pbDownloadThreadCount.setValue(int(config.downloadthreadcount))
	self.txtSaveDir.setText(config.savedir)
	self.txtPlayer.setText(config.player)
	self.txtSaveTempDir.setText(config.savetempdir)
	if bool(config.overwrite):
	    self.cbOverwrite.setCheckState(Qt.Checked)
	else:self.cbOverwrite.setCheckState(Qt.Unchecked)
	self.dsbMinSize.setValue(float(config.minfilesize))
	self.dsbMaxSize.setValue(float(config.maxfilesize))
	if 'mp3' in config.filetypes:
	    self.cbMp3.setCheckState(Qt.Checked)
	else:self.cbMp3.setCheckState(Qt.Unchecked)
	if 'wma' in config.filetypes:
	    self.cbWma.setCheckState(Qt.Checked)
	else:self.cbWma.setCheckState(Qt.Unchecked)
	if 'rm' in config.filetypes:
	    self.cbRm.setCheckState(Qt.Checked)
	else:self.cbRm.setCheckState(Qt.Unchecked)
    def saveconfig(self):

	'''
	fetchthreadcount=4
	downloadthreadcount=4
	savedir='/home/shrek/Music/'#must end with '/'
	savetempdir='/home/shrek/Music/temp/'#must end with '/'
	overwrite=False #if local file exists, overwrite it?
	minfilesize=3 #if file size less than this, don't get the song info. (M)
	maxfilesize=10 #if file size larger than this, don't get the song info. (M)
	filetypes=['mp3','wma'] #file type to get,if file type is not in this list, don't get the song info
	'''
	config.fetchthreadcount=self.pbFetchThreadCount.value()
	config.downloadthreadcount=self.pbDownloadThreadCount.value()
	config.savedir=self.txtSaveDir.text()
	config.player=self.txtPlayer.text()
	config.savetempdir=self.txtSaveTempDir.text()
	config.overwrite=self.cbOverwrite.isChecked()
	config.minfilesize=self.dsbMinSize.value()
	config.maxfilesize=self.dsbMaxSize.value()
	ftypes=[]
	if self.cbMp3.isChecked():
	    ftypes.append('mp3')
	if self.cbWma.isChecked():
	    ftypes.append('wma')
	if self.cbRm.isChecked():
	    ftypes.append('rm')
	config.filetypes=ftypes
	config.writeconfig()
	
    def accept(self):
	if self.validate():
	    self.saveconfig()
	    QMessageBox.information(self, u'提醒', u'线程设置需要重启应用程序才会生效。')
	    return QDialog.accept(self)

class MyMainWindow(QMainWindow, ui_mainwindow.Ui_MainWindow,MixIn):
    downactionames=['actdown%s'%name for name in baiducat]
    getactionames=['actget%s'%name for name in baiducat]
    playlistactionames=['actplaylist%s'%name for name in baiducat]
    @classmethod
    def populate(cls):
        i=0
        for action in cls.downactionames:
            funcstr='''def dodownload(self):
            self.baiduwidget.tabWidget.setCurrentIndex(%s)
            self.baiduwidget.on_btnDownloadAll_clicked()'''%(i)
            i=i+1
            exec(funcstr)
            setattr(cls,'do%s'%action,dodownload)
	i=0
        for action in cls.getactionames:
            func='''def doget(self):
            self.baiduwidget.tabWidget.setCurrentIndex(%s)
            self.baiduwidget.on_btnFetch_clicked()'''%(i)
            i=i+1
            exec(func)
            setattr(cls,'do%s'%action,doget)
	i=0
        for action in cls.playlistactionames:
            func='''def doplaylist(self):
	    self.baiduwidget.tabWidget.setCurrentIndex(%s)
            self.baiduwidget.generateplaylist()'''%i
            i=i+1
            exec(func)
            setattr(cls,'playlist%s'%action,doplaylist)
    def __init__(self, parent=None):
    	super(MyMainWindow, self).__init__(parent)
    	self.setupUi(self)
        self.downactions={}
        self.getactions={}
	self.playlistactions={}
    	self.createTrayIcon()
	self.baiduwidget=BaiduWidget(self)	
    	self.setCentralWidget(self.baiduwidget)
        self.initmenu()
    
    def initmenu(self):
        global baiducat,baiducatnames
        i=0
        for name in baiducatnames:
            self.downactions[self.downactionames[i]]=eval("self.createAction(u'%s', slot=self.do%s, tip=u'%s')"%
            (u'下载%s'%baiducatnames[i],self.downactionames[i],u'下载%s'%baiducatnames[i]))
            i=i+1
        i=0
        for name in baiducatnames:
            self.getactions[self.getactionames[i]]=eval("self.createAction(u'%s', slot=self.do%s, tip=u'%s')"%
            (u'获取%s'%baiducatnames[i],self.getactionames[i], u'获取%s'%baiducatnames[i]))
            i=i+1
	i=0
        for name in baiducatnames:
            self.playlistactions[self.playlistactionames[i]]=eval("self.createAction(u'%s', slot=self.playlist%s, tip=u'%s')"%
            (u'生成%s播放列表'%baiducatnames[i],self.playlistactionames[i], u'生成%s播放列表'%baiducatnames[i]))
            i=i+1
	self.addActions(self.mPlayList, self.playlistactions.values())
        self.addActions(self.mGetMusic, self.getactions.values())
        self.addActions(self.mDownMusic, self.downactions.values())
    def createTrayIcon(self):
         self.trayIconMenu = QMenu(self)
         
         self.trayIconMenu.addSeparator()
	 self.trayIconMenu.addMenu(self.mGetMusic)
	 self.trayIconMenu.addMenu(self.mDownMusic)
	 self.trayIconMenu.addMenu(self.mPlayList)
	 self.trayIconMenu.addAction(self.action_X)
	 
         self.trayIcon = QSystemTrayIcon(self)
         self.trayIcon.setContextMenu(self.trayIconMenu)
	 self.trayIcon.setIcon(QIcon(':/musicex/images/main.png'))
	 self.connect(self.trayIcon, SIGNAL('activated(QSystemTrayIcon::ActivationReason)'), self.on_trayIcon_activated)
	 self.trayIcon.show()
    @pyqtSignature("")
    def on_action_X_triggered(self):
	QCoreApplication.quit()
    @pyqtSignature("")
    def on_action_Close_triggered(self):
	self.hide()    
    @pyqtSignature("")
    def on_action_triggered(self):
	AboutDialog(self).exec_()
    @pyqtSignature("")
    def on_action_P_triggered(self):
	OptionDialog(self).exec_()
    def closeEvent(self,event):
	event.ignore()
	self.hide()    
    def on_trayIcon_activated(self, reason):
	if reason==QSystemTrayIcon.DoubleClick or reason==QSystemTrayIcon.Trigger:
	    self.setVisible(not self.isVisible())
class BaiduWidget(QWidget, ui_downloadwidgetui.Ui_DownloadWidget,MixIn):   
    fetchedurl=[]
    tablemodels=[]
    
    def __init__(self, parent=None):
	super(BaiduWidget, self).__init__(parent)
	self.setupUi(self)
	self.inittableviews()
	self.tabWidget.setCurrentIndex(0)
	self.mydownloader=downloader.MusicDownloader()	
    def inittableviews(self):
	for cat in baiducat:
	    model=MusicTableModel()
	    tableview=eval('self.tableView_%s'%cat)
	    tableview.horizontalHeader().setResizeMode (QHeaderView.Stretch)
	    tableview.setAutoScroll(True)
	    tableview.setModel(model)
	    tableview.setSortingEnabled(True)
	    tableview.setSelectionBehavior(QAbstractItemView.SelectRows)
	    tableview.setAlternatingRowColors(True)
	    self.connect(tableview, SIGNAL('doubleClicked (const QModelIndex&)'), self.on_table_view_dclick)
	    self.tablemodels.append(model)	
	self.playlistmodel=MusicTableModel()
	self.downloadmodel=MusicTableModel()
	self.tableView_playlist.setModel(self.playlistmodel)
	self.tableView_download.setModel(self.downloadmodel)
	self.connect(self.tableView_download, SIGNAL('doubleClicked (const QModelIndex&)'), self.on_table_view_dclick)
    def on_table_view_dclick(self, modelindex):
	self.on_btnDownload_clicked()
    def gettableview(self):
	       return eval('self.tableView_%s'%baiducat[self.tabWidget.currentIndex()])
    def getmodel(self):
	       return self.tablemodels[self.tabWidget.currentIndex()]
    def getcaturl(self):
	       return baiducaturls[self.tabWidget.currentIndex()]
    def getSelectedMusics(self):
    	musics=[]
    	tableview=self.gettableview()
    	selectionmodel=tableview.selectionModel()
    	selectedrows=selectionmodel.selectedRows()
    	for modelindex in selectedrows:
    	    musics.append(self.getmodel().musiccontainer[modelindex.row()])
    	return musics
    def fetchurl(self, urls, showtip=True):
    	for url in urls:
    	    if url in self.fetchedurl:
    		if showtip:
    		    QMessageBox.information(self, u'提醒', u'就等等吧，正在拿呢！ @_@')
    	    else:
    		self.fetchedurl.append(url)
    		myscrawler=eval('scrawler.%sFetcher'%baiducat[baiducaturls.index(url)])
    		fetcher=myscrawler(url, self.tablemodels[baiducaturls.index(url)])
    		fetcher.setDaemon(True)
    		fetcher.start()
    def generateplaylist(self):	
	playlist=""
	for musicitem in self.getmodel().musiccontainer:
	    playlist+=musicitem.url
	    playlist+='\n'
	savedir=str(QFileDialog.getSaveFileName())
	if savedir:
	    open(savedir,'w').write(playlist)
	    self.mplayer.loadlist(savedir)
    def updatedownloadprog(self,music):
	music.downloadmodels.append(self.downloadmodel)
	music.downloadmodels.append(self.getmodel())
	self.downloadmodel.insertRows(self.downloadmodel.rowCount()-1,musicitems=[music])
	#self.getmodel().insertRows(self.getmodel().rowCount()-1,musicitems=[music])
    @pyqtSignature("")
    def on_btnDownload_clicked(self):
	musicitems=self.getSelectedMusics()
	musics=[]
	for music in musicitems:
	    if music.isDownloading==True or music.isDownloaded==True:
		continue
	    music.state=u'等待下载中'	    
	    self.updatedownloadprog(music)
	    musics.append(music)	
	self.mydownloader.download(musics)
    @pyqtSignature("")
    def on_btnDownloadAll_clicked(self):
	musicitems=self.getmodel().musiccontainer
	musics=[]
	for music in musicitems:
	    if music.isDownloading==True or music.isDownloaded==True:
		continue
	    self.updatedownloadprog(music)
	    music.state=u'等待下载中'
	    musics.append(music)
	self.mydownloader.download(musics)
    @pyqtSignature("")
    def on_btnFetch_clicked(self):	
	url=self.getcaturl()
	self.fetchurl([url])
    @pyqtSignature("")
    def on_btnFetchAll_clicked(self):	
	self.fetchurl(baiducaturls, False)	
    @pyqtSignature("")
    def on_btnOptions_clicked(self):
	OptionDialog(self).exec_()
    @pyqtSignature("")
    def on_btnAbout_clicked(self):
	AboutDialog(self).exec_()    
    def contextMenuEvent(self,event):
	if not self.tabWidget.currentWidget().rect().contains(event.pos()):
	    event.ignore()
	    return
	if self.tabWidget.currentIndex() in [9,10]:
	    pass
	else:
	    menu=QMenu(self)
	    menu.addAction(self.createAction(u'获取',slot=self.on_btnFetch_clicked))
	    menu.addAction(self.createAction(u'选中下载',slot=self.on_btnDownload_clicked))
	    menu.addAction(self.createAction(u'全部下载',slot=self.on_btnDownloadAll_clicked))
	    menu.addAction(self.createAction(u'选中播放',slot=self.play))
	    menu.addAction(self.createAction(u'退出',slot=self.quitapp))
	    menu.addSeparator()
	    menu.popup(event.globalPos())
    def play(self):
	musicitems=self.getSelectedMusics()	
	import tempfile
	fd,filename=tempfile.mkstemp(suffix='.m3u')
	print filename
	playlist=''
	for music in musicitems:
	    playlist+=music.url
	    playlist+='\n'
	open(filename,'w').write(playlist)
	#open('/home/shrek/playlist.m3u','w').write(playlist)
	import subprocess
	subprocess.Popen('%s %s'%(config.player,filename),shell=True)
    @pyqtSignature("int")
    def on_tabWidget_currentChanged(self, index):
	if index in [9,10]:
	    self.widget.hide()
	else:
	    self.widget.setVisible(True)
	    self.btnFetch.setText(u'获取%s'%self.tabWidget.tabText(index))    
	    self.btnDownload.setText(u'下载选定%s'%self.tabWidget.tabText(index))
	    self.btnDownloadAll.setText(u'下载所有%s'%self.tabWidget.tabText(index))
	    